/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     VALUE = 259,
     IDENTIFIER = 260,
     OBJECT = 261,
     UNIT_ANGLE = 262,
     UNIT_COLOR = 263,
     UNIT_RATIO = 264,
     UNIT_SIZE = 265,
     UNIT_SPEED = 266,
     UNIT_TIME = 267,
     FOR = 268,
     IF = 269,
     ACTION_SCRIPT = 270,
     ELSE = 271,
     RANGE = 272,
     LOGICAL_OR = 273,
     LOGICAL_XOR = 274,
     LOGICAL_AND = 275,
     GREATER_EQUAL = 276,
     LESS_EQUAL = 277,
     NOT_EQUAL = 278,
     EQUAL = 279,
     ROTATE_RIGHT = 280,
     ROTATE_LEFT = 281,
     SHIFT_RIGHT_UNSIGNED = 282,
     SHIFT_RIGHT = 283,
     SHIFT_LEFT = 284,
     MAX_OP = 285,
     MIN_OP = 286,
     POWER = 287,
     NEG = 288,
     POS = 289
   };
#endif
#define STRING 258
#define VALUE 259
#define IDENTIFIER 260
#define OBJECT 261
#define UNIT_ANGLE 262
#define UNIT_COLOR 263
#define UNIT_RATIO 264
#define UNIT_SIZE 265
#define UNIT_SPEED 266
#define UNIT_TIME 267
#define FOR 268
#define IF 269
#define ACTION_SCRIPT 270
#define ELSE 271
#define RANGE 272
#define LOGICAL_OR 273
#define LOGICAL_XOR 274
#define LOGICAL_AND 275
#define GREATER_EQUAL 276
#define LESS_EQUAL 277
#define NOT_EQUAL 278
#define EQUAL 279
#define ROTATE_RIGHT 280
#define ROTATE_LEFT 281
#define SHIFT_RIGHT_UNSIGNED 282
#define SHIFT_RIGHT 283
#define SHIFT_LEFT 284
#define MAX_OP 285
#define MIN_OP 286
#define POWER 287
#define NEG 288
#define POS 289




/* Copy the first part of user declarations.  */
#line 1 "src\\sswf\\sswf_grammar.y"
	/* sswf_grammar.y -- written by Alexis WILKE for Made to Order Software Corp. (c) 2002-2009 */
	/* grammar parser for the SWF scripting tool */

/*

Copyright (c) 2002-2009 Made to Order Software Corp.

Permission is hereby granted, free of charge, to any
person obtaining a copy of this software and
associated documentation files (the "Software"), to
deal in the Software without restriction, including
without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom
the Software is furnished to do so, subject to the
following conditions:

The above copyright notice and this permission notice
shall be included in all copies or substantial
portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF
ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO
EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

*/


#include	"sswf.h"

#define	YYPARSE_PARAM		result
static	void			yyerror(const char *msg);





/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 48 "src\\sswf\\sswf_grammar.y"
typedef union YYSTYPE {
	struct node_t		*node;
	enum node_type_t	type;		/* for UNIT */
	int			unused;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 193 "tmp\\object\\src\\sswf\\sswf_grammar.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 217 "tmp\\object\\src\\sswf\\sswf_grammar.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  34
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   946

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  15
/* YYNRULES -- Number of rules. */
#define YYNRULES  78
/* YYNRULES -- Number of states. */
#define YYNSTATES  172

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   289

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    46,     2,     2,    57,    44,    26,     2,
      58,    59,    42,    40,    55,    41,    51,    43,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    19,    52,
      27,    17,    28,    18,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    56,    25,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    53,    24,    54,    47,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    20,    21,    22,    23,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    45,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,     7,     9,    11,    14,    16,    20,
      22,    26,    28,    32,    35,    38,    41,    44,    47,    50,
      54,    59,    64,    68,    71,    74,    77,    80,    84,    89,
      93,    97,   101,   105,   109,   113,   117,   121,   125,   129,
     133,   137,   141,   145,   149,   153,   157,   161,   165,   169,
     173,   177,   181,   185,   189,   193,   199,   209,   213,   215,
     217,   219,   221,   222,   228,   239,   246,   252,   255,   256,
     257,   265,   266,   268,   270,   272,   276,   280,   282
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      61,     0,    -1,    64,    62,    -1,    -1,    63,    -1,    52,
      -1,    63,    52,    -1,    65,    -1,    64,    63,    65,    -1,
      67,    -1,    53,    64,    54,    -1,    67,    -1,    66,    55,
      67,    -1,    67,     7,    -1,    67,     8,    -1,    67,     9,
      -1,    67,    10,    -1,    67,    11,    -1,    67,    12,    -1,
      67,    51,    67,    -1,    67,    50,    66,    56,    -1,    57,
      58,    66,    59,    -1,    58,    66,    59,    -1,    40,    67,
      -1,    41,    67,    -1,    46,    67,    -1,    47,    67,    -1,
       5,    58,    59,    -1,     5,    58,    66,    59,    -1,    67,
      45,    67,    -1,    67,    42,    67,    -1,    67,    43,    67,
      -1,    67,    44,    67,    -1,    67,    40,    67,    -1,    67,
      41,    67,    -1,    67,    39,    67,    -1,    67,    38,    67,
      -1,    67,    37,    67,    -1,    67,    36,    67,    -1,    67,
      35,    67,    -1,    67,    34,    67,    -1,    67,    33,    67,
      -1,    67,    32,    67,    -1,    67,    31,    67,    -1,    67,
      27,    67,    -1,    67,    30,    67,    -1,    67,    28,    67,
      -1,    67,    29,    67,    -1,    67,    26,    67,    -1,    67,
      25,    67,    -1,    67,    24,    67,    -1,    67,    23,    67,
      -1,    67,    22,    67,    -1,    67,    21,    67,    -1,    67,
      20,    67,    -1,    67,    18,    66,    19,    67,    -1,    14,
      58,    66,    59,    53,    64,    62,    54,    68,    -1,     5,
      17,    67,    -1,    69,    -1,     5,    -1,     4,    -1,     3,
      -1,    -1,    16,    53,    64,    62,    54,    -1,    16,    14,
      58,    66,    59,    53,    64,    62,    54,    68,    -1,     6,
      72,    53,    73,    62,    54,    -1,     6,    72,    53,    62,
      54,    -1,     6,    72,    -1,    -1,    -1,    15,    72,    53,
      70,     3,    71,    54,    -1,    -1,     5,    -1,     3,    -1,
      74,    -1,    73,    63,    74,    -1,     5,    19,    66,    -1,
      66,    -1,    13,    58,     5,    17,    67,    52,    67,    52,
      67,    59,    53,    73,    62,    54,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   100,   100,   107,   109,   113,   114,   119,   123,   131,
     135,   146,   150,   158,   163,   168,   173,   178,   183,   188,
     194,   200,   205,   221,   226,   231,   236,   241,   247,   253,
     259,   265,   271,   277,   283,   289,   295,   301,   307,   313,
     319,   325,   331,   337,   343,   349,   355,   361,   367,   373,
     379,   385,   391,   397,   403,   417,   424,   431,   438,   442,
     446,   450,   459,   462,   466,   477,   487,   496,   506,   508,
     505,   532,   535,   539,   551,   555,   564,   570,   576
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "VALUE", "IDENTIFIER", "OBJECT", 
  "UNIT_ANGLE", "UNIT_COLOR", "UNIT_RATIO", "UNIT_SIZE", "UNIT_SPEED", 
  "UNIT_TIME", "FOR", "IF", "ACTION_SCRIPT", "ELSE", "'='", "'?'", "':'", 
  "RANGE", "LOGICAL_OR", "LOGICAL_XOR", "LOGICAL_AND", "'|'", "'^'", 
  "'&'", "'<'", "'>'", "GREATER_EQUAL", "LESS_EQUAL", "NOT_EQUAL", 
  "EQUAL", "ROTATE_RIGHT", "ROTATE_LEFT", "SHIFT_RIGHT_UNSIGNED", 
  "SHIFT_RIGHT", "SHIFT_LEFT", "MAX_OP", "MIN_OP", "'+'", "'-'", "'*'", 
  "'/'", "'%'", "POWER", "'!'", "'~'", "NEG", "POS", "'['", "'.'", "';'", 
  "'{'", "'}'", "','", "']'", "'$'", "'('", "')'", "$accept", "start", 
  "opt_end", "colons", "expr_list", "block_expr", "group_expr", "expr", 
  "opt_else", "object", "@1", "@2", "opt_name", "object_definition", 
  "definition", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,    61,    63,    58,
     272,   273,   274,   275,   124,    94,    38,    60,    62,   276,
     277,   278,   279,   280,   281,   282,   283,   284,   285,   286,
      43,    45,    42,    47,    37,   287,    33,   126,   288,   289,
      91,    46,    59,   123,   125,    44,    93,    36,    40,    41
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    60,    61,    62,    62,    63,    63,    64,    64,    65,
      65,    66,    66,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    68,    68,    68,    69,    69,    69,    70,    71,
      69,    72,    72,    72,    73,    73,    74,    74,    74
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     0,     1,     1,     2,     1,     3,     1,
       3,     1,     3,     2,     2,     2,     2,     2,     2,     3,
       4,     4,     3,     2,     2,     2,     2,     3,     4,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     5,     9,     3,     1,     1,
       1,     1,     0,     5,    10,     6,     5,     2,     0,     0,
       7,     0,     1,     1,     1,     3,     3,     1,    14
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    61,    60,    59,    71,     0,    71,     0,     0,     0,
       0,     0,     0,     0,     0,     3,     7,     9,    58,     0,
       0,    73,    72,    67,     0,     0,    23,    24,    25,    26,
       0,     0,     0,    11,     1,     5,     2,     4,    13,    14,
      15,    16,    17,    18,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,    27,     0,     3,     0,    68,    10,
       0,     0,     0,    22,     6,     8,     0,    54,    53,    52,
      51,    50,    49,    48,    44,    46,    47,    45,    43,    42,
      41,    40,    39,    38,    37,    36,    35,    33,    34,    30,
      31,    32,    29,     0,    19,    28,    59,     0,     0,     4,
      77,     3,    74,     0,     0,    21,    12,     0,    20,     0,
       0,    66,     0,     4,     0,    69,    55,    76,     0,    65,
      75,     3,     0,     0,     0,    70,     0,    62,     0,     0,
      56,     0,     0,     0,     0,     0,     3,     0,     0,     0,
       0,     0,    63,     0,     0,     3,     3,     0,     0,    78,
      62,    64
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    14,    36,    37,    15,    16,   120,    33,   150,    18,
     124,   142,    23,   121,   122
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -60
static const short yypact[] =
{
     227,   -60,   -60,    25,    18,   -28,    18,   255,   255,   255,
     255,   227,   -17,   255,    15,    26,   -60,   433,   -60,   255,
      83,   -60,   -60,    23,   255,    31,   531,   531,   531,   531,
     -25,   255,   -43,   433,   -60,   -60,   -60,   153,   -60,   -60,
     -60,   -60,   -60,   -60,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     255,   255,   255,   433,   -60,   -42,   167,   -41,   -60,   -60,
     153,   -35,   255,   -60,   -60,   -60,   -16,   523,   568,   613,
     658,   703,   748,   793,   838,   838,   838,   838,   838,   838,
     838,   838,   838,   838,   838,   850,   850,   895,   895,   761,
     761,   761,   761,   -50,    24,   -60,    21,    19,    36,    39,
      40,    26,   -60,    41,    93,   -60,   433,   255,   -60,   255,
      94,   -60,    46,   182,   227,   -60,   478,    40,    84,   -60,
     -60,    26,    48,   255,    49,   -60,   341,    88,   255,   -10,
     -60,   387,    51,   227,   255,   255,    26,   296,   -33,    52,
      54,    57,   -60,   241,   227,    26,    26,    58,    59,   -60,
      88,   -60
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -60,   -60,   -48,    -5,    -9,   -36,    61,     0,   -59,   -60,
     -60,   -60,   108,   -44,   -18
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      17,    85,    30,   127,   152,    82,   128,    26,    27,    28,
      29,    17,    82,    82,    82,    34,    83,   115,   123,    73,
      82,    21,    82,    22,   125,    80,   161,    35,   118,    79,
      24,    38,    39,    40,    41,    42,    43,    17,    19,    82,
     129,    31,    19,   153,    85,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   119,   114,   132,    32,    72,    76,   130,    35,    20,
      17,    75,   126,    20,    78,    77,     1,     2,     3,     4,
     131,    84,    81,   144,   134,    82,   135,     5,     6,   138,
     139,   143,   145,   147,   149,    86,   162,   163,   159,   155,
     164,   171,   169,   170,    25,   140,   133,   167,   168,   165,
       0,     0,     0,     7,     8,   141,     0,   136,     0,     9,
      10,     0,   113,     0,    17,     0,     0,     0,     0,     0,
      12,    13,    74,   146,   156,     0,     0,     0,   151,     0,
       0,     0,     0,    17,   157,   166,     1,     2,     3,     4,
     133,     0,     0,     0,    17,     0,     0,     5,     6,     0,
       1,     2,   116,     4,     0,     0,     0,     0,     0,     0,
     117,     5,     6,     0,     0,     1,     2,   116,     4,     0,
     137,     0,     0,     7,     8,   117,     5,     6,     0,     9,
      10,     0,     0,     0,     0,    84,    11,     7,     8,     0,
      12,    13,     0,     9,    10,     0,   158,     0,     0,    35,
       0,     0,     7,     8,    12,    13,     0,     0,     9,    10,
       1,     2,     3,     4,    84,     0,     0,     0,     0,    12,
      13,     5,     6,     0,     1,     2,   116,     4,     0,     0,
       0,     0,     0,     0,   117,     5,     6,     0,     1,     2,
       3,     4,     0,     0,     0,     0,     0,     7,     8,     5,
       6,     0,     0,     9,    10,     0,     0,     0,     0,     0,
      11,     7,     8,     0,    12,    13,     0,     9,    10,     0,
       0,     0,     0,     0,     0,     7,     8,     0,    12,    13,
       0,     9,    10,    38,    39,    40,    41,    42,    43,     0,
       0,     0,    12,    13,    44,     0,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,     0,     0,     0,     0,    71,    72,    38,    39,
      40,    41,    42,    43,     0,   160,     0,     0,     0,    44,
       0,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,     0,     0,     0,
       0,    71,    72,   148,    38,    39,    40,    41,    42,    43,
       0,     0,     0,     0,     0,    44,     0,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,     0,     0,     0,     0,    71,    72,   154,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,    44,     0,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,    38,    39,
      40,    41,    42,    43,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,    71,    72,     0,     0,     0,     0,     0,     0,     0,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,     0,    38,    39,
      40,    41,    42,    43,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      38,    39,    40,    41,    42,    43,    70,     0,     0,     0,
       0,    71,    72,     0,     0,     0,     0,     0,     0,     0,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,     0,
       0,     0,     0,    71,    72,    38,    39,    40,    41,    42,
      43,     0,     0,     0,     0,     0,     0,    38,    39,    40,
      41,    42,    43,     0,     0,     0,     0,     0,     0,     0,
       0,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,     0,     0,     0,     0,    71,    72,
      65,    66,    67,    68,    69,    70,     0,     0,     0,     0,
      71,    72,    38,    39,    40,    41,    42,    43,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    67,    68,    69,
      70,     0,     0,     0,     0,    71,    72
};

static const short yycheck[] =
{
       0,    37,    11,    19,    14,    55,    56,     7,     8,     9,
      10,    11,    55,    55,    55,     0,    59,    59,    59,    19,
      55,     3,    55,     5,    59,    30,    59,    52,    76,    54,
      58,     7,     8,     9,    10,    11,    12,    37,    17,    55,
      19,    58,    17,    53,    80,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    76,    72,   121,    13,    51,    53,    58,    52,    58,
      80,    20,    82,    58,    53,    24,     3,     4,     5,     6,
      54,    52,    31,   141,    53,    55,     3,    14,    15,     5,
      54,    17,    54,    54,    16,    44,    54,    53,   156,    58,
      53,   170,    54,    54,     6,   133,   121,   165,   166,   163,
      -1,    -1,    -1,    40,    41,   134,    -1,   127,    -1,    46,
      47,    -1,    71,    -1,   134,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,   143,   153,    -1,    -1,    -1,   148,    -1,
      -1,    -1,    -1,   153,   154,   164,     3,     4,     5,     6,
     165,    -1,    -1,    -1,   164,    -1,    -1,    14,    15,    -1,
       3,     4,     5,     6,    -1,    -1,    -1,    -1,    -1,    -1,
      13,    14,    15,    -1,    -1,     3,     4,     5,     6,    -1,
     129,    -1,    -1,    40,    41,    13,    14,    15,    -1,    46,
      47,    -1,    -1,    -1,    -1,    52,    53,    40,    41,    -1,
      57,    58,    -1,    46,    47,    -1,   155,    -1,    -1,    52,
      -1,    -1,    40,    41,    57,    58,    -1,    -1,    46,    47,
       3,     4,     5,     6,    52,    -1,    -1,    -1,    -1,    57,
      58,    14,    15,    -1,     3,     4,     5,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    13,    14,    15,    -1,     3,     4,
       5,     6,    -1,    -1,    -1,    -1,    -1,    40,    41,    14,
      15,    -1,    -1,    46,    47,    -1,    -1,    -1,    -1,    -1,
      53,    40,    41,    -1,    57,    58,    -1,    46,    47,    -1,
      -1,    -1,    -1,    -1,    -1,    40,    41,    -1,    57,    58,
      -1,    46,    47,     7,     8,     9,    10,    11,    12,    -1,
      -1,    -1,    57,    58,    18,    -1,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    -1,    -1,    -1,    50,    51,     7,     8,
       9,    10,    11,    12,    -1,    59,    -1,    -1,    -1,    18,
      -1,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    -1,    -1,
      -1,    50,    51,    52,     7,     8,     9,    10,    11,    12,
      -1,    -1,    -1,    -1,    -1,    18,    -1,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,    52,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    18,    -1,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,     7,     8,
       9,    10,    11,    12,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     7,     8,
       9,    10,    11,    12,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
       7,     8,     9,    10,    11,    12,    45,    -1,    -1,    -1,
      -1,    50,    51,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      -1,    -1,    -1,    50,    51,     7,     8,     9,    10,    11,
      12,    -1,    -1,    -1,    -1,    -1,    -1,     7,     8,     9,
      10,    11,    12,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    -1,    -1,    -1,    50,    51,
      40,    41,    42,    43,    44,    45,    -1,    -1,    -1,    -1,
      50,    51,     7,     8,     9,    10,    11,    12,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    43,    44,
      45,    -1,    -1,    -1,    -1,    50,    51
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     3,     4,     5,     6,    14,    15,    40,    41,    46,
      47,    53,    57,    58,    61,    64,    65,    67,    69,    17,
      58,     3,     5,    72,    58,    72,    67,    67,    67,    67,
      64,    58,    66,    67,     0,    52,    62,    63,     7,     8,
       9,    10,    11,    12,    18,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    50,    51,    67,    59,    66,    53,    66,    53,    54,
      63,    66,    55,    59,    52,    65,    66,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    66,    67,    59,     5,    13,    62,    63,
      66,    73,    74,    59,    70,    59,    67,    19,    56,    19,
      58,    54,    62,    63,    53,     3,    67,    66,     5,    54,
      74,    64,    71,    17,    62,    54,    67,    54,    52,    16,
      68,    67,    14,    53,    52,    58,    64,    67,    66,    62,
      59,    59,    54,    53,    53,    73,    64,    62,    62,    54,
      54,    68
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yytype, yyvaluep, yylocationp)
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  YYLTYPE *yylerrsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 101 "src\\sswf\\sswf_grammar.y"
    {
	  	/* the returned value is the result */
		* (struct node_t **) result = yyvsp[-1].node;
	  ;}
    break;

  case 7:
#line 120 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 8:
#line 124 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-2].node;
		node_link_tail(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 9:
#line 132 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 10:
#line 136 "src\\sswf\\sswf_grammar.y"
    {
		/* this is equivalent to a LIST without a name */
		yyval.node = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_BLOCK, yylsp[-2].first_line);
		/* left = NULL -- always unamed object */
		node_link_right(yyval.node, yyvsp[-1].node);
		node_link_object(yyval.node);
	  ;}
    break;

  case 11:
#line 147 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 12:
#line 151 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-2].node;
		node_link_tail(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 13:
#line 159 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_ANGLE] = yyvsp[0].type;
	  ;}
    break;

  case 14:
#line 164 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_COLOR] = yyvsp[0].type;
	  ;}
    break;

  case 15:
#line 169 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_RATIO] = yyvsp[0].type;
	  ;}
    break;

  case 16:
#line 174 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_SIZE] = yyvsp[0].type;
	  ;}
    break;

  case 17:
#line 179 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_SPEED] = yyvsp[0].type;
	  ;}
    break;

  case 18:
#line 184 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		yyval.node->unit[NODE_UNIT_TIME] = yyvsp[0].type;
	  ;}
    break;

  case 19:
#line 189 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FIELD, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 20:
#line 195 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SUBSCRIPT, yylsp[-3].first_line);
		node_link_left(yyval.node, yyvsp[-3].node);
		node_link_right(yyval.node, yyvsp[-1].node);
	  ;}
    break;

  case 21:
#line 201 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_EXPAND, yylsp[-3].first_line);
		node_link_left(yyval.node, yyvsp[-1].node);
	  ;}
    break;

  case 22:
#line 206 "src\\sswf\\sswf_grammar.y"
    {
		if(yyvsp[-1].node->next != NULL) {
			/* Check whether the expr returns a list of nodes...
			 * This happens when a comma is used between multiple expressions.
			 * We need to have a 'GROUP' node because all the children are affected
			 * by the following token(s) such as a UNIT.
			 */
			yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GROUP, yylsp[-2].first_line);
			node_link_left(yyval.node, yyvsp[-1].node);
		}
		else {
			/* no worry, we don't need to add another node */
		  	yyval.node = yyvsp[-1].node;
		}
	  ;}
    break;

  case 23:
#line 222 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IDENTITY, yylsp[-1].first_line);
		node_link_left(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 24:
#line 227 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NEGATE, yylsp[-1].first_line);
		node_link_left(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 25:
#line 232 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_NOT, yylsp[-1].first_line);
		node_link_left(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 26:
#line 237 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NOT, yylsp[-1].first_line);
		node_link_left(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 27:
#line 242 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FUNCTION, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		/* right = NULL -- no parameters */
	  ;}
    break;

  case 28:
#line 248 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_FUNCTION, yylsp[-3].first_line);
		node_link_left(yyval.node, yyvsp[-3].node);
		node_link_right(yyval.node, yyvsp[-1].node);
	  ;}
    break;

  case 29:
#line 254 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_POWER, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 30:
#line 260 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MULTIPLY, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 31:
#line 266 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_DIVIDE, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 32:
#line 272 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MODULO, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 33:
#line 278 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ADD, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 34:
#line 284 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SUBTRACT, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 35:
#line 290 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MINIMUM, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 36:
#line 296 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_MAXIMUM, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 37:
#line 302 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_LEFT, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 38:
#line 308 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_RIGHT, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 39:
#line 314 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SHIFT_RIGHT_UNSIGNED, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 40:
#line 320 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ROTATE_LEFT, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 41:
#line 326 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_ROTATE_RIGHT, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 42:
#line 332 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_EQUAL, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 43:
#line 338 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_NOT_EQUAL, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 44:
#line 344 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LESS, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 45:
#line 350 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LESS_EQUAL, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 46:
#line 356 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GREATER, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 47:
#line 362 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_GREATER_EQUAL, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 48:
#line 368 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_AND, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 49:
#line 374 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_XOR, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 50:
#line 380 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_OR, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 51:
#line 386 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_AND, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 52:
#line 392 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_XOR, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 53:
#line 398 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_LOGICAL_OR, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 54:
#line 404 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_RANGE, yylsp[-2].first_line);
		if(yyvsp[-2].node->type == NODE_TYPE_OPERATOR && yyvsp[-2].node->sub_type == NODE_SUBTYPE_RANGE) {
			fprintf(stderr, "ERROR: at line #%d: can't have two ranges defined one after another.\n", yylsp[-1].first_line);
			return -1;
		}
		if(yyvsp[0].node->type == NODE_TYPE_OPERATOR && yyvsp[0].node->sub_type == NODE_SUBTYPE_RANGE) {
			fprintf(stderr, "ERROR: at line #%d: can't have two ranges defined one after another.\n", yylsp[-1].first_line);
			return -1;
		}
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 55:
#line 418 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_SELECT, yylsp[-4].first_line);
		node_link_select(yyval.node, yyvsp[-4].node);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 56:
#line 425 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IF, yylsp[-8].first_line);
		node_link_select(yyval.node, yyvsp[-6].node);
		node_link_left(yyval.node, yyvsp[-3].node);
		node_link_right(yyval.node, yyvsp[0].node);	/* may be a null pointer */
	  ;}
    break;

  case 57:
#line 432 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_VARIABLE, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
		node_link_object(yyval.node);
	  ;}
    break;

  case 58:
#line 439 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 59:
#line 443 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 60:
#line 447 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 61:
#line 451 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 62:
#line 459 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = NULL;
	  ;}
    break;

  case 63:
#line 463 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-2].node;
	  ;}
    break;

  case 64:
#line 467 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = node_alloc(NODE_TYPE_OPERATOR, NODE_SUBTYPE_IF, yylsp[-9].first_line);
		node_link_select(yyval.node, yyvsp[-6].node);
		node_link_left(yyval.node, yyvsp[-3].node);
		node_link_right(yyval.node, yyvsp[0].node);	/* may be a null pointer */
	  ;}
    break;

  case 65:
#line 478 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-5].node;
		/* keep only non-empty names, it simplifies some other parts of the code! */
		if(yyvsp[-4].node != NULL && yyvsp[-4].node->string != NULL && *yyvsp[-4].node->string != '\0') {
			node_link_left(yyval.node, yyvsp[-4].node);
		}
		node_link_right(yyval.node, yyvsp[-2].node);
		node_link_object(yyval.node);
	  ;}
    break;

  case 66:
#line 488 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-4].node;
		if(yyvsp[-3].node != NULL && yyvsp[-3].node->string != NULL && *yyvsp[-3].node->string != '\0') {
			node_link_left(yyval.node, yyvsp[-3].node);
		}
		/* right = NULL -- no data for this object */
		node_link_object(yyval.node);
	  ;}
    break;

  case 67:
#line 497 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-1].node;
		if(yyvsp[0].node != NULL && yyvsp[0].node->string != NULL && *yyvsp[0].node->string != '\0') {
			node_link_left(yyval.node, yyvsp[0].node);
		}
		/* right = NULL -- no data for this object */
		node_link_object(yyval.node);
	  ;}
    break;

  case 68:
#line 506 "src\\sswf\\sswf_grammar.y"
    { sswf_read_actionscript(1); ;}
    break;

  case 69:
#line 508 "src\\sswf\\sswf_grammar.y"
    { sswf_read_actionscript(0); ;}
    break;

  case 70:
#line 510 "src\\sswf\\sswf_grammar.y"
    {
	  	struct node_t	*n;

		/*
		 * Note: we use the 1st line of the STRING so we can generate
		 * proper errors in the Javascript compiler.
		 */
		yyval.node = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_ACTION_SCRIPT, yylsp[-2].first_line);
		if(yyvsp[-5].node != NULL && yyvsp[-5].node->string != NULL && *yyvsp[-5].node->string != '\0') {
			node_link_left(yyval.node, yyvsp[-5].node);
		}
	  	n = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, yylsp[-6].first_line);
		/* left = NULL -- no label */
		node_link_right(n, yyvsp[-2].node);
		node_link_right(yyval.node, n);
		node_link_object(yyval.node);
	  ;}
    break;

  case 71:
#line 532 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = NULL;
	  ;}
    break;

  case 72:
#line 536 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 73:
#line 540 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 74:
#line 552 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = yyvsp[0].node;
	  ;}
    break;

  case 75:
#line 556 "src\\sswf\\sswf_grammar.y"
    {
		yyval.node = yyvsp[-2].node;
		node_link_tail(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 76:
#line 565 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, yylsp[-2].first_line);
		node_link_left(yyval.node, yyvsp[-2].node);
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 77:
#line 571 "src\\sswf\\sswf_grammar.y"
    {
	  	yyval.node = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, yylsp[0].first_line);
		/* left = NULL -- no label */
		node_link_right(yyval.node, yyvsp[0].node);
	  ;}
    break;

  case 78:
#line 577 "src\\sswf\\sswf_grammar.y"
    {
		struct node_t	*for_obj, *var, *result, *block;

		block = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_BLOCK, yylsp[-13].first_line);
		/* node_link_left() -- no name/label */
		node_link_right(block, yyvsp[-2].node);

		var = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_VARIABLE, yylsp[-13].first_line);
		result = node_alloc(NODE_TYPE_INTEGER, NODE_SUBTYPE_UNKNOWN, yylsp[-13].first_line);
		node_link_left(var, yyvsp[-11].node);
		node_link_right(var, result);	/* the result of different expr's */
		node_link_object(var);

		node_link_tail(var, yyvsp[-9].node);
		node_link_tail(var, yyvsp[-7].node);
		node_link_tail(var, yyvsp[-5].node);
		node_link_tail(var, block);

		for_obj = node_alloc(NODE_TYPE_OBJECT, NODE_SUBTYPE_FOR, yylsp[-13].first_line);
		/*node_link_left(for_obj, ...) -- no name for a loop - should we use the variable name? */
		node_link_right(for_obj, var);
		/*node_link_object(for_obj);	-- this makes this software crash and it's not necessary (no name!) */

	  	yyval.node = node_alloc(NODE_TYPE_DEFINITION, NODE_SUBTYPE_UNKNOWN, yylsp[-13].first_line);
		/* left = NULL -- no label */
		node_link_right(yyval.node, for_obj);
	  ;}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2081 "tmp\\object\\src\\sswf\\sswf_grammar.c"

  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }

  yylerrsp = yylsp;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp, yylsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval, &yylloc);
      yychar = YYEMPTY;
      *++yylerrsp = yylloc;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif

  yylerrsp = yylsp;
  *++yylerrsp = yyloc;
  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp, yylsp);
      yyvsp--;
      yystate = *--yyssp;
      yylsp--;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
  YYLLOC_DEFAULT (yyloc, yylsp, (yylerrsp - yylsp));
  *++yylsp = yyloc;

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 607 "src\\sswf\\sswf_grammar.y"



void yyerror(const char *msg)
{
	/* TODO: enhance this message! */
	printf("YACC ERROR at line #%d in file \"%s\": %s.\n", yylloc.first_line, lex_filename, msg);
}





